
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif

#define ENV	"BPF_RANGE"
#define LEN	(131072/4)

static struct {
		double	z1,z2;
	} R[LEN]={{0.0,0.5}};

static int	s=1,L=1;
static double	S=0.25;

static void	Env()
{
	if (!s) return;
{
	char	*e,*E;
	double	z1,z2;
	int	n1,n2,l;

	s=0;
	if ((e=E=getenv(ENV))!=NULL) {
	    S=0.0;
	    for (L=0; L<LEN; L++) {
		if (sscanf(e,"%lf%n",&z1,&n1)!=1) break;

		for (e+=n1; *e==' ' || *e=='\t' || *e==':'; e++, n1++) ;

		if (sscanf(e,"%lf%n",&z2,&n2)!=1) { e-=n1; break; }

		for (e+=n2; *e==' ' || *e=='\t' || *e==','; e++) ;

		if (z1<0.0 || z2>0.5 || z1>=z2) {
		(void)fprintf(stderr,"%lf:%lf : bad range.\n",z1,z2); exit(1);
		}
		for (l=0; l<L; l++)
		    if (z2>R[l].z1 && z1<R[l].z2) {
	(void)fprintf(stderr,"%lf:%lf : overlapping range.\n",z1,z2); exit(1);
		}
		R[L].z1=z1; R[L].z2=z2; S+=(z2*z2-z1*z1);
	    }
	    if (L==0) {
		(void)fprintf(stderr,"no range : %s\n",E); exit(1);
	    }
	    if (*e!='\0')
		(void)fprintf(stderr,"range remains (warning) : %s\n",e);
	}
#ifdef	DEBUG
	for (l=0; l<L; l++) (void)fprintf(stderr,"%lf\t%lf\n",R[l].z1,R[l].z2);
#endif
}}

static double	I(double t)
{
	int	l;
	double	i=0.0;

	for (l=0; l<L; l++) i+=(cos(t*R[l].z2)-cos(t*R[l].z1));

	return i/t;
}

static double	H(double t)
{
	int	l;
	double	h=I(t);

	for (l=0; l<L; l++) h+=(R[l].z2*sin(t*R[l].z2)-R[l].z1*sin(t*R[l].z1));

	return h/t;
}

double	BPF_R(int r)
{
	Env();

	return (r==0)?S:2.0*H(2.0*M_PI*(double)r);
}

double	BPF_S(int r)
{
	Env();

	return (I(M_PI*(double)(2*r-1))-I(M_PI*(double)(2*r+1)))/M_PI;
}

double	BPF_C(int r)
{
	Env();

	return (r==0)?S/2.0+H(2.0*M_PI):
	       (r==(-1) || r==1)?S/4.0+H(2.0*M_PI)+H(4.0*M_PI)/2.0:
	       (H(2.0*M_PI*(double)(r-1))+
		H(2.0*M_PI*(double)(r+1)))/2.0+H(2.0*M_PI*(double)r);
}
