
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rif_f.h"
#include "csi_f.h"

extern void	Error(char *msg);

static void	Projection(double I0,double I,FILE *file)
{
	double	p=(I0<=0.0 || I<=0.0)?0.0:log(I0/I);

	(void)fwrite(&p,sizeof(double),1,file);
}

int	main(int argc,char **argv)
{
	char	**path;
	int	Ns,Nz,Nv,V,Nl,Nr,Nlr,Z,v,s,z;
	FILE	*file;
	FOM	**F,*f;
	double	l,r,a,b;

	if (argc!=7) Error("usage : i0e_s RI/ NF left right layer SG");

	path=CheckSliceImages_Float(argv[1],argv[2],&Ns,&Nz,&Nv,NULL);

	if (Nv<2) Error("too few views.");

	V=Nv-1; free(path[V]);

	if ((Nl=atoi(argv[3]))<0 ||
	    (Nr=atoi(argv[4]))<0 || (Nlr=Nl+Nr)<=0 || Nlr>=Ns)
	    Error("bad left and/or right margin.");

	if ((Z=atoi(argv[argc-2]))<0 || Z>=Nz) Error("bad sinogram layer.");

	if (argv[argc-1][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[argc-1],"wb"))==NULL) Error("file not open.");

	(void)fprintf(file,"%d\t%d\n",Ns,V);

	for (v=0; v<V; v++) {
	    (void)ReadImageFile_Float(path[v],&s,&z,&F,NULL);
	    if (s!=Ns || z!=Nz) Error("image size not match.");

	    f=F[Z]; l=0.0; for (s=0    ; s<Nl; s++) l+=f[s];
		    r=0.0; for (s=Ns-Nr; s<Ns; s++) r+=f[s];

	    if (Nl==0 || Nr==0) {
		a=0.0; b=(l+r)/(double)Nlr;
	    }
	    else {
		l/=(double)Nl;
		r/=(double)Nr; a=(r-l)/((double)Ns-(double)Nlr/2.0);
			       b=l-a*(double)(Nl-1)/2.0;
	    }
	    for (s=0; s<Ns; s++) Projection(b+a*(double)s,*(f++),file);

	    for (z=0; z<Nz; z++) free(F[z]); free(F); free(path[v]);
	}
	if (file!=stdout) (void)fclose(file);

	free(path); 

	return 0;
}
